//*****************************************************************************
//*
//*
//*		Thread.h
//*
//*
//*****************************************************************************
//
//	Thread Module for Win32,LINUX,FreeRtos,Cmsis and RTTARGET
//	Copyright Anton Zechner (c) 2000
//
#ifndef	  __THREAD_H__
#define   __THREAD_H__

#ifdef		GLOBAL_CONFIG
#define 	THREAD_H
#include	<GlobalConfig.h>
#undef		THREAD_H
#endif

#if     	defined(_CMSIS_OS_H) || defined(RTL)
#include    "cmsis_os.h"
#endif

#ifdef	  __cplusplus
extern		"C" {
#endif

#ifdef	   _MSC_VER
#pragma 	warning( disable :4996 )
#endif

#define		THREAD_GLOBAL	0x80000000                  // absolute global priority for threads

#ifndef		THREAD_CHECK
#ifdef		RTTARGET
#define 	THREAD_CHECK	1							// store ckeck points
#else
#define 	THREAD_CHECK	0
#endif
#endif

#ifdef	  __ICCARM__
#ifndef	  __cdecl
#define	  __cdecl
#endif
#ifndef	   _cdecl
#define	   _cdecl
#endif
#endif

#ifdef	  __GNUC__
#ifndef	  __cdecl
#define	  __cdecl
#endif
#ifndef	   _cdecl
#define	   _cdecl
#endif
#endif

#ifdef		LINUX
#ifndef		linux
#define		linux			1
#endif
#endif

#ifndef	FREERTOS
#define	FREERTOS
#endif

//********************* LINUX **************************************************
/*
#ifdef	linux

	typedef	void       *ThreadSemaphore;
	ThreadSemaphore		ThreadSemaphoreInitEx	   (int iNum);
	#define				ThreadSemaphoreInit()		ThreadSemaphoreInitEx(1)
	#define 			ThreadSemaphoreRelease		ThreadSemaphoreReleaseEx(1);
	#define 			ThreadSemaphoreReleaseIsr	ThreadSemaphoreReleaseEx(1);
	void				ThreadSemaphoreExit		   (ThreadSemaphore hSemaphore);
	extern	void 		ThreadSemaphoreWait		   (ThreadSemaphore hSemaphore);
	extern	int 		ThreadSemaphoreTimed	   (ThreadSemaphore hSemaphore,unsigned uMillisec);
	extern  int			ThreadSemaphoreCount	   (ThreadSemaphore hSemaphore);
	extern	void 		ThreadSemaphoreReleaseEx   (ThreadSemaphore hSemaphore,int iCount);
	extern	void 		ThreadSleep				   (unsigned uMillSec);
	extern	char       *ThreadTlsPointer		   ();
	extern	unsigned	ThreadTickCount			   ();
*/

//********************* RTTARGET **********************************************
/*
#elif defined(RTTARGET)

	#ifdef		   _MSC_VER
	#ifndef		   _MT
	#error			"Multithread not activated"
	#endif
	#endif

	#ifndef       __EVENTUTILITY_H__
	#ifndef       __THREAD_C__
	#ifndef        _CLOCK_H
	extern			long			__declspec(dllexport)   _cdecl	CLKTicksToMilliSecs(unsigned long);
	extern			long			__declspec(dllexport)   _cdecl	CLKMilliSecsToTicks(unsigned long);
	#endif
	#ifndef        _RTK32_H
	extern			unsigned long	__declspec(dllexport)   _cdecl	RTKGetTime(void);
	extern			void            __declspec(dllexport) * _cdecl	RTKOpenSemaphore(int,unsigned,unsigned long,const char*);
	extern			void			__declspec(dllexport)   _cdecl	RTKDeleteSemaphore(void **);
	extern			void 			__declspec(dllexport)   _cdecl	RTKDelay(unsigned long);
	extern			void 			__declspec(dllexport)   _cdecl	RTKSignal(void*);
	extern			unsigned long	__declspec(dllexport)   _cdecl	RTKWaitTimed(void*,unsigned long);
	extern			void 			__declspec(dllexport)   _cdecl	RTKWait(void*);
	extern			void 			__declspec(dllexport)  *_cdecl	RTKGetUserData(void*,int);
	extern			void 			__declspec(dllexport)   _cdecl	RTKResetEvent(void*);
	extern			void 			__declspec(dllexport)   _cdecl	RTKPulse(void*);
	typedef			void *ThreadSemaphore;
	typedef 		enum { ST_COUNTING,ST_RESOURCE,ST_BINARY,ST_EVENT,ST_MUTEX} RTKSemaType;
	#else
	typedef			RTKSemaphore ThreadSemaphore;
	#endif
	#else
	typedef			void *ThreadSemaphore;
	#endif
	#endif


	#define 		ThreadSemaphoreInit()			(ThreadSemaphore)RTKOpenSemaphore(ST_COUNTING,1,0,0)
	#define 		ThreadSemaphoreInitEx(n)		(ThreadSemaphore)RTKOpenSemaphore(ST_COUNTING,n,0,0)
	#define 		ThreadSemaphoreExit(h)			RTKDeleteSemaphore(&h)
	#define 		ThreadSemaphoreWait(h)			RTKWait(h)
	#define 		ThreadSemaphoreTimed(h,t)		RTKWaitTimed(h,CLKMilliSecsToTicks(t))
	#define 		ThreadSemaphoreRelease(h)		RTKSignal(h)
	#define 		ThreadSemaphoreReleaseIsr(h)	RTKSignal(h)
	#define 		ThreadSemaphoreCount(h)	  ((int)RTKSemaValue(h))


	#define			ThreadSleep(t)					RTKDelay(CLKMilliSecsToTicks(t))
	#define 		ThreadTlsPointer()				((char*)RTKGetUserData(RTKCurrentTaskHandle(),iThreadTlsNum))
	void			ThreadSemaphoreReleaseEx		(ThreadSemaphore hSemaphore,int iCount);
	unsigned		ThreadTickCount();
	extern int		iThreadTlsNum;

*/
//********************* FREERTOS **********************************************
//#elif defined(FREERTOS)


	#ifdef		   _MSC_VER
	#ifndef		   _MT
	#error			"Multithread not activated"
	#endif
	#endif

	#ifdef		  __ICCARM__
	#ifndef		   _cdecl
	#define 	   _cdecl
	#endif
	#ifndef		  __cdecl
	#define 	  __cdecl
	#endif
    #endif
	#ifndef	      __THREAD_C__
	#ifndef			INC_TASK_H

	void			vTaskDelay(const unsigned long);
	unsigned long	xTaskGetTickCount(void);
	void		   *xTaskGetApplicationTaskTag(void*);
	void		   *xTaskGetCurrentTaskHandle(void);

	#endif
	#endif

	#ifndef	        INC_FREERTOS_H
	#ifndef		  __THREAD_C__

	#ifndef			xSemaphoreCreateCounting
	#define			xSemaphoreCreateCounting(c,n)	xQueueCreateCountingSemaphore(c,n)
	#endif

	#ifndef			vSemaphoreDelete
	#define			vSemaphoreDelete(h)				vQueueDelete(h)
	#endif

	#ifndef			xSemaphoreTake
	#define			xSemaphoreTake(h,t)				xQueueGenericReceive(h,0,t,0)
	#endif

	#ifndef			xSemaphoreGive
	#define			xSemaphoreGive(h)				xQueueGenericSend(h,0,0,0)
	#endif

	#ifndef 		xSemaphoreGetCount
	#define			xSemaphoreGetCount(h)			xSemaphoreGetCount(h)
	#endif

	extern void		vQueueDelete(void *);
	extern void	   *xQueueCreateCountingSemaphore(const unsigned long,const unsigned long);
	extern long		xQueueGenericReceive(void*,const void *,unsigned long,const long);
	extern long		xQueueGenericSend   (void*,const void *,unsigned long,const long);
	extern int 		xQueueGetSemaphoreCount(void*);

	#endif
	#endif


	#ifdef			portMAX_DELAY
	#define 		SYS_MAX_DELAY					portMAX_DELAY
	#else
	#define 		SYS_MAX_DELAY					0xFFFFFFFF
	#endif

	#ifdef			configTICK_RATE_HZ
	#ifdef			SYS_TICK_RATE_HZ
	#undef			SYS_TICK_RATE_HZ
	#endif
	#define 		SYS_TICK_RATE_HZ				configTICK_RATE_HZ
	#endif


	#ifdef			SYS_TICK_RATE_HZ

		#if			SYS_TICK_RATE_HZ==1000
		#define 	ThreadSleep(t)					vTaskDelay(t)
		#define 	ThreadTickCount()				xTaskGetTickCount()
		#define 	SYS_MS_TO_TICKS(m)				(m)
		#else
		#define 	ThreadSleep(t)					ThreadSleepInternal(t)
		#define 	ThreadTickCount()				ThreadTickCountInternal()
		#define 	SYS_MS_TO_TICKS(m)				(((m)*SYS_TICK_RATE_HZ)/1000)
		#endif

	#else

		#define 	ThreadSleep(t)					ThreadSleepInternal(t)
		#define 	ThreadTickCount()				ThreadTickCountInternal()
		#define 	SYS_MS_TO_TICKS(m)				ThreadSysToTicks(m)

	#endif

	typedef void   *ThreadSemaphore;
	#define 		ThreadSemaphoreInit()			xSemaphoreCreateCounting(0x70000000,1)
	#define			ThreadSemaphoreInitEx(n)		xSemaphoreCreateCounting(0x70000000,n)
	#define 		ThreadSemaphoreExit(h)			vSemaphoreDelete(h)
	#define			ThreadSemaphoreWait(h)			{if(ThreadSemCheck(h,__FILE__,__LINE__))   xSemaphoreTake(h,SYS_MAX_DELAY);}
	#define 		ThreadSemaphoreTimed(h,t)		(  (ThreadSemCheck(h,__FILE__,__LINE__) && xSemaphoreTake(h,SYS_MS_TO_TICKS(t)))? 1:0)
	#define			ThreadSemaphoreRelease(h)		xSemaphoreGive(h)
	#define 		ThreadSemaphoreReleaseEx(h,c)	{int iSemDown=c;for(;iSemDown>0;iSemDown--)ThreadSemaphoreRelease(h);}
	#define			ThreadSemCheck(a,b,c)			1

	#define 		ThreadTlsPointer()				((char*)xTaskGetApplicationTaskTag(xTaskGetCurrentTaskHandle()))
	#define 		ThreadSemaphoreCount(h)			xQueueGetSemaphoreCount(h)

	extern unsigned	ThreadTickCountInternal			();
	extern void		ThreadSleepInternal				(unsigned uMillSec);
	extern int 		ThreadSysToTicks				(unsigned uMillSec);
	extern void		ThreadSemaphoreReleaseIsr		(ThreadSemaphore hSemaphore);

	#ifndef			__THREAD_C__
	#define 		main	FreeRtosMainTask
	#endif

//********************* CIMSIS or Keil RTX ************************************
/*
#elif defined(_CMSIS_OS_H) || defined(RTL)

	#ifndef		   _cdecl
	#define 	   _cdecl
	#endif

	#ifndef		  __cdecl
	#define 	  __cdecl
	#endif

	#ifndef			THREAD_CHECK
	#define 		THREAD_CHECK	0
	#else
	#undef			THREAD_CHECK
	#define 		THREAD_CHECK	0
	#endif

	#ifndef			THREAD_NAMES
	#define 		THREAD_NAMES	0
	#else
	#undef			THREAD_NAMES
	#define 		THREAD_NAMES	0
	#endif

	#ifdef			THREAD_TLS_SIZE
	#if				THREAD_TLS_SIZE>0
	#error			RTL not supports TLS memory
	#endif
	#endif

	typedef	void   *ThreadSemaphore;
	void			ThreadSemaphoreExit     		(ThreadSemaphore hSemHandle);
	#define			ThreadSemaphoreInit()    		ThreadSemaphoreInitEx(1)
	ThreadSemaphore	ThreadSemaphoreInitEx   		(int iNum);

	extern  int 	ThreadSemaphoreCount    		(ThreadSemaphore h);
	extern	void	ThreadSemaphoreReleaseEx		(ThreadSemaphore hSemHandle,int iCount);
	#define			ThreadSemaphoreWait(h)			osSemaphoreWait   ((osSemaphoreId)h,osWaitForever)
	#define			ThreadSemaphoreTimed(h,t)   	osSemaphoreWait   ((osSemaphoreId)h,t)
	#define			ThreadSemaphoreRelease(h)		osSemaphoreRelease((osSemaphoreId)h)

	#define			ThreadSleep(uMillSec)			osDelay(uMillSec)
	#define			ThreadTlsPointer()				0
	unsigned		ThreadTickCount(void);
*/
//********************* WINDOWS ***********************************************
/*
#else

	#ifdef		   _MSC_VER
	#ifndef		   _MT
	#error			"Multithread not activated"
	#endif
	#endif

	#ifndef	      __THREAD_C__
	#ifndef	       _WINDOWS_
	extern			void            __declspec(dllexport) * __stdcall	CreateSemaphoreA(void*,long,long,const char*);
	extern			unsigned long	__declspec(dllexport)   __stdcall	WaitForSingleObject(void *,unsigned long);
	extern			unsigned long	__declspec(dllexport)   __stdcall	GetTickCount(void);
	extern			int				__declspec(dllexport)   __stdcall	ReleaseSemaphore(void *,long,long*);
	extern			int				__declspec(dllexport)   __stdcall	CloseHandle(void*);
	extern			void            __declspec(dllexport)   __stdcall	Sleep(unsigned long);
	extern			void            __declspec(dllexport) * __stdcall	TlsGetValue(unsigned long);
	#endif
	#endif

	#ifndef			CreateSemaphore
	#define 		CreateSemaphore	CreateSemaphoreA
	#endif

	#ifdef         _DEBUG
	int 			ThreadSemError(const char *pFile,int iLine);
	#define			ThreadSemCheck(a,b,c)	(a || !ThreadSemError(b,c))
	#else
	#define			ThreadSemCheck(a,b,c)	1
	#endif

	typedef void   *ThreadSemaphore;
	#define 		ThreadSemaphoreInit()			CreateSemaphore(0,1,0x70000000,0)
	#define			ThreadSemaphoreInitEx(n)		CreateSemaphore(0,n,0x70000000,0)
	#define 		ThreadSemaphoreExit(h)			CloseHandle(h)
	#define			ThreadSemaphoreWait(h)			{if(ThreadSemCheck(h,__FILE__,__LINE__))   WaitForSingleObject(h,0xFFFFFFFF);}
	#define 		ThreadSemaphoreTimed(h,t)		(  (ThreadSemCheck(h,__FILE__,__LINE__) && WaitForSingleObject(h,t)==0)? 1:0)
	#define			ThreadSemaphoreRelease(h)		ReleaseSemaphore(h,1,0)
	#define 		ThreadSemaphoreReleaseIsr(h)	ReleaseSemaphore(h,1,0)
	#define 		ThreadSemaphoreReleaseEx(h,c)	ReleaseSemaphore(h,c,0)

	#define			ThreadTickCount()				GetTickCount()
	#define			ThreadSleep(t)					Sleep(t)
	#define 		ThreadTlsPointer()				((char*)TlsGetValue(iThreadTlsNum))

	extern int		ThreadSemaphoreCount			(ThreadSemaphore hSemaphore);
	extern int		iThreadTlsNum;

#endif
*/
extern unsigned 	ThreadSecCount(void);
extern void	       *ThreadStartEx (void(_cdecl  *pStartAddress)(void*),unsigned uStackSize,void *pParameter,int iPriority,const char *pName);
#define				ThreadStart(pStartAddress,uStackSize,pParameter,iPriority) ThreadStartEx(pStartAddress,uStackSize,pParameter,iPriority,0)
extern void 		ThreadSetName (const char *pName);
extern const char  *ThreadGetName (void);


//******************** General Functions **************************************


#if	THREAD_CHECK
extern void			ThreadCheckSet   (const char *pFile,int   iLine);
extern void 		ThreadCheckSetSub(const char *pFile,int   iLine  ,unsigned uHandle);
extern int			ThreadCheckGet   (void       *hTask,char *pBuffer,int iSize,int iAddPath);
extern int  		ThreadCheckGetSub(void       *hTask,char *pBuffer,int iSize,int iAddPath);
#define				ThreadCheck()		ThreadCheckSet(__FILE__,__LINE__)
#define				ThreadCheckSub(h)	ThreadCheckSet(__FILE__,__LINE__,h)
#else
#define				ThreadCheck()
#define				ThreadCheckSub(h)
#endif


#ifdef	__cplusplus
}
#endif

#endif
